# Iterátor a iterovatelná hodnota jako objekty

class Ones:
    """Iterátor jedniček."""
    def __next__(self):
        return 1
    
    def __iter__(self):
        return self

"""
>>> i = Ones()
>>> next(i)
1
>>> next(i)
1
>>> next(i)
1
"""

# Možná implementace průchodu prvků v poli:
class ArrayIter:
    def __init__(self, array):
        self.array = array
        self.index = 0
        
    def __next__(self):
        if self.index == len(self.array):
            raise StopIteration
        el = self.array[self.index]
        self.index = self.index + 1
        return el
    
    def __iter__(self):
        return self

"""
>>> i = ArrayIter([1, 2, 3])
>>> next(i)
1
>>> next(i)
2
>>> next(i)
3
>>> next(i)
StopIteration
"""


class Words:
    def __init__(self, string):
        self.string = string
        
    def __iter__(self):
        return iter(self.string.split(" "))

"""
>>> for word in Words("ahoj světe"):
        print(word)
ahoj
světe
"""

