# Eratosthenovo síto

def get_numbers():
    i = 0
    while True:
        yield i
        i = i + 1

"""
>>> i = get_numbers()
>>> next(i)
0
>>> next(i)
1
>>> next(i)
2 
...
"""

def is_divisor(a, b):
    return (b % a) == 0

"""
>>> is_divisor(2, 8)
True
>>> is_divisor(2, 7)
False
"""

def remove_multiples(n, iterable):
    return filter(lambda m: not is_divisor(n, m), iterable)

"""
>>> i = remove_multiples(2, get_numbers())
>>> next(i)
1
>>> next(i)
3
>>> next(i)
5 
...
"""


"""
>>> numbers = get_numbers()
>>> next(numbers)
0
>>> next(numbers)
1
>>> prime = next(numbers)
>>> numbers = remove_multiples(prime, numbers)
>>> prime
2
>>> prime = next(numbers)
>>> numbers = remove_multiples(prime, numbers)
>>> prime
3
>>> prime = next(numbers)
>>> numbers = remove_multiples(prime, numbers)
>>> prime
5
"""

def get_primes():
    numbers = get_numbers()
    next(numbers)
    next(numbers)
    while True:
        prime = next(numbers)
        numbers = remove_multiples(prime, numbers)
        yield prime

primes = get_primes()
for i in range(100):
    print(next(primes))

# Všechna prvočísla:
"""
for prime in get_primes():
    print(prime)
"""
